#ifndef __NT2__CORE__DEFINITION__AST__SCALAR_HPP__INCLUDED
#define __NT2__CORE__DEFINITION__AST__SCALAR_HPP__INCLUDED

////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2003-2008 LASMEA UMR 6602 du CNRS.
// Copyright (c) 2007-2008 IEF    UMR 8622 du CNRS.
// All rights reserved.
//
// License information are available in the LICENSE file.
// Additionnal informations are available in the INFOS file.
////////////////////////////////////////////////////////////////////////////////

#include <boost/proto/proto.hpp>
#include <boost/proto/transform.hpp>

namespace nt2
{
  ////////////////////////////////////////////////////////////////////////////
  // Scalar terminals grammar.
  ////////////////////////////////////////////////////////////////////////////
  struct arithmetic_grammar : lambda_grammar< is_arithmetic<bm::_> > {};

  ////////////////////////////////////////////////////////////////////////////
  // Integral terminals grammar.
  ////////////////////////////////////////////////////////////////////////////
  struct integer_grammar : lambda_grammar< is_integral<bm::_> > {};

  ////////////////////////////////////////////////////////////////////////////
  // Floating-point terminals grammar.
  ////////////////////////////////////////////////////////////////////////////
  struct real_grammar : lambda_grammar< is_floating_point<bm::_> > {};

  ////////////////////////////////////////////////////////////////////////////
  // Complex terminals grammar.
  ////////////////////////////////////////////////////////////////////////////
  struct complex_grammmar : lambda_grammar< is_complex<bm::_> > {};

  ////////////////////////////////////////////////////////////////////////////
  // NT2-compatible scalar terminals grammar.
  ////////////////////////////////////////////////////////////////////////////
  struct data_grammmar : lambda_grammar< is_data<bm::_> > {};
}

#endif

