#ifndef __NT2__CORE__DEFINITION__CONTAINER__DIMEN__CONTEXT_HPP__INCLUDED
#define __NT2__CORE__DEFINITION__CONTAINER__DIMEN__CONTEXT_HPP__INCLUDED

////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2003-2008 LASMEA UMR 6602 du CNRS.
// Copyright (c) 2007-2008 IEF    UMR 8622 du CNRS.
// All rights reserved.
//
// License information are available in the LICENSE file.
// Additionnal informations are available in the INFOS file.
////////////////////////////////////////////////////////////////////////////////

#include <boost/proto/context.hpp>

namespace nt2
{
  ////////////////////////////////////////////////////////////////////////////
  // Evaluation context that evaluates into a complex expression
  ////////////////////////////////////////////////////////////////////////////
  struct dimen_context : bp::callable_context<dimen_context const>
  {
    typedef size_t              result_type;

    //////////////////////////////////////////////////////////////////////////
    // Context initialisation
    //////////////////////////////////////////////////////////////////////////
    dimen_context( size_t idx = 0 ) : mIndex(idx) {}

    //////////////////////////////////////////////////////////////////////////
    // Increment context value
    //////////////////////////////////////////////////////////////////////////
    void operator++(int)      { ++mIndex;     }

    //////////////////////////////////////////////////////////////////////////
    // Set context value
    //////////////////////////////////////////////////////////////////////////
    void reset( int idx=0) { mIndex = idx; }

    //////////////////////////////////////////////////////////////////////////
    // dimen terminal acces
    //////////////////////////////////////////////////////////////////////////
    template<class N,class S> inline result_type
    operator()(bp::tag::terminal,dimensions<N,S> const& s) const 
    { 
      return s[mIndex]; 
    }

    //////////////////////////////////////////////////////////////////////////
    // constant terminal acces
    ////////////////////////////////////////////////////////////////////////////
    template<class V> inline
    typename boost::enable_if<is_integral<V>,result_type>::type
    operator()(bp::tag::terminal,V const& v) const 
    { 
      return v; 
    }

    private:
    int mIndex;
  };
}

#endif

