#ifndef __NT2__CORE__DEFINITION__CONTAINER__DIMEN__DOMAIN_HPP__INCLUDED
#define __NT2__CORE__DEFINITION__CONTAINER__DIMEN__DOMAIN_HPP__INCLUDED

////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2003-2008 LASMEA UMR 6602 du CNRS.
// Copyright (c) 2007-2008 IEF    UMR 8622 du CNRS.
// All rights reserved.
//
// License information are available in the LICENSE file.
// Additionnal informations are available in the INFOS file.
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
/// @file
/// @brief Identify entity from the dimen domain
////////////////////////////////////////////////////////////////////////////////

namespace nt2
{
  //////////////////////////////////////////////////////////////////////////////
  // Type evaluation for dimen parent
  //////////////////////////////////////////////////////////////////////////////
  template<size_t N,class S> struct make_dimen
  {
    typedef typename bm::apply1<S,bm::size_t<N> >::type type;
  };

  //////////////////////////////////////////////////////////////////////////////
  // Support for size_type_of meta-function
  //////////////////////////////////////////////////////////////////////////////
  template<size_t N,class S> struct size_type_for< dimen<N,S> >
  {
    typedef typename bm::apply1<OfSize<1,N>,bm::size_t<2> >::type type;
  };
}

NT2_IDENTIFY_TYPE_ID(dimen_domain)
#endif
