#ifndef __NT2__CORE__DEFINITION__CONTAINER__DIMEN__EXPRESSION_HPP__INCLUDED
#define __NT2__CORE__DEFINITION__CONTAINER__DIMEN__EXPRESSION_HPP__INCLUDED

////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2003-2008 LASMEA UMR 6602 du CNRS.
// Copyright (c) 2007-2008 IEF    UMR 8622 du CNRS.
// All rights reserved.
//
// License information are available in the LICENSE file.
// Additionnal informations are available in the INFOS file.
////////////////////////////////////////////////////////////////////////////////

namespace nt2
{
  template<class X> struct dimen_expr : bp::extends<X,dimen_expr<X>,dimen_domain>
  {
    typedef bp::extends<X,dimen_expr<X>,dimen_domain> ext_type;
    typedef typename size_<X>::type                   size_type;
    static const size_t size_value = size_<X>::base::value;
    typedef numel_t                                   value_type;

    dimen_expr(X const& expr=X()) : ext_type( expr ) {}

    size_t operator()(const int idx) const
    {
      return bp::eval(*this,dimen_context(idx));
    }

    size_type const& size() const { return mSize; }

    private:
    size_type mSize;
  };

  ////////////////////////////////////////////////////////////////////////////
  // Tell proto that in the dimen_domain, all
  // expressions should be wrapped in dimen_expr<>
  ////////////////////////////////////////////////////////////////////////////
  struct dimen_domain : bp::domain<bp::generator<dimen_expr>,dimen_grammar> {};
}

#endif


