#ifndef __NT2__CORE__DEFINITION__CONTAINER__DIMEN__IO_HPP__INCLUDED
#define __NT2__CORE__DEFINITION__CONTAINER__DIMEN__IO_HPP__INCLUDED

////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2003-2008 LASMEA UMR 6602 du CNRS.
// Copyright (c) 2007-2008 IEF    UMR 8622 du CNRS.
// All rights reserved.
//
// License information are available in the LICENSE file.
// Additionnal informations are available in the INFOS file.
////////////////////////////////////////////////////////////////////////////////

namespace nt2
{
  //////////////////////////////////////////////////////////////////////////////
  /// @file
  /// @brief Send a dimen instance to a stream
  //////////////////////////////////////////////////////////////////////////////
  template<class Expr>
  static inline std::ostream& operator<<( std::ostream& os, dimen_expr<Expr> const& d )
  {
    static const size_t up = dimen_expr<Expr>::size_value;
    os << "[";
    for(size_t i=0;i<up-1; i++) os << d(i) << ",";
    os << d(up-1)<< "]";
    return os;
  }
}
#endif
